using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace HeroSquareRoots
{
    public partial class Form1 : Form
    {
        HeroCalc calc = new HeroCalc();
        bool cancel = false;

        public Form1()
        {
            InitializeComponent();
            calc.OnUpdateProgress += new EventHandler<CalcProgressArgs>(calc_OnUpdateProgress);
       }

        private void startCalc(object unused)
        {
            double src = double.Parse(textBoxSquare.Text);
            calc.DoCalc(src, 1E-12);
        }

        private delegate void UIUpdater(CalcProgressArgs args);

        void calc_OnUpdateProgress(object sender, CalcProgressArgs e)
        {
            if (InvokeRequired)
                Invoke(new UIUpdater(UpdateUI), e);
            else
                UpdateUI(e);
        }

        private void UpdateUI(CalcProgressArgs e)
        {
            textBoxApproximation.Text = e.CurrentStatus.Guess.ToString();
            textBoxError.Text = e.CurrentStatus.Epsilon.ToString();
            textBoxNumApproximations.Text = e.CurrentStatus.NumIterations.ToString();
            listBoxHistory.DataSource = calc.GetEpsilon(50);
            Invalidate(true);
            Update();
            e.Cancel = cancel || e.CurrentStatus.NumIterations > 10000;
            if (e.Done || e.Cancel)
            {
                buttonStart.Enabled = true;
                buttonStop.Enabled = false;
            }
        }

        private void buttonStart_Click(object sender, EventArgs e)
        {
            cancel = false;
            double src = double.Parse(textBoxSquare.Text);
            buttonStart.Enabled = false;
            buttonStop.Enabled = true;
            calc.DoCalc(src, 1E-12);
        }

        private void button1_Click(object sender, EventArgs e)
        {
           cancel = true;
        }

        private void buttonThreads_Click(object sender, EventArgs e)
        {
            cancel = false;
            buttonStart.Enabled = false;
            buttonStop.Enabled = true;
            System.Threading.ThreadPool.QueueUserWorkItem(new System.Threading.WaitCallback(this.startCalc));
        }
    }
}