using System;
using System.Collections.Generic;
using System.Text;

namespace HeroSquareRoots
{
    public class HeroStatus
    {
        private readonly double operand;
        private readonly double guess;
        private readonly int numIterations;

        public double Operand
        {
            get { return operand; }
        }

        public double Guess
        {
            get { return guess; }
        }

        public int NumIterations
        {
            get { return numIterations; }
        }

        public double Epsilon
        {
            get { return Math.Abs(operand - guess*guess); }
        }

        public HeroStatus(double value, double approximation, int iterations)
        {
            operand = value;
            guess = approximation;
            numIterations = iterations;
        }
    }
}
